Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/SelfTest/src/test.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/SelfTest/src/test.cpp	(revision 78)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/SelfTest/src/test.cpp	(revision 81)
@@ -104,6 +208,429 @@
     {
       LABEL("Iteration %d",iteration);
-
+      
+      {
+	uint32_t context = rand() % _param->_nb_context;
+	
+// 	LABEL("KANE : %d",context);
+
+	LABEL("PREDICT - fill the queue");
+	
+	{
+	  uint32_t port = rand() % _param->_nb_inst_predict;
+	  
+	  for (uint32_t i=0; i<_param->_size_queue[context]; i++)
+	    {
+	      
+	      bool find = false;
+	      do
+		{
+		  in_PREDICT_VAL              [port]->write((rand()%100)<percent_transaction_predict);
+		  in_PREDICT_CONTEXT_ID       [port]->write(context);
+		  in_PREDICT_BTB_ADDRESS_SRC  [port]->write(0xdeadbeef+i);
+		  in_PREDICT_BTB_ADDRESS_DEST [port]->write(0x21071981+i);
+		  in_PREDICT_BTB_CONDITION    [port]->write(BRANCH_CONDITION_FLAG_SET);
+		  in_PREDICT_BTB_LAST_TAKE    [port]->write(1);
+		  in_PREDICT_BTB_IS_ACCURATE  [port]->write((rand()%100)<percent_transaction_predict);
+		  in_PREDICT_DIR_HISTORY      [port]->write(i);
+		  in_PREDICT_RAS_ADDRESS      [port]->write(0xdeaddead+i);
+		  in_PREDICT_RAS_INDEX        [port]->write((0x12345678+i)%_param->_size_ras_index[context]);
+		  
+		  if (_param->_have_port_depth)
+		    {
+		      TEST(Tdepth_t,out_DEPTH_TAIL     [context]->read(), 0);
+		      TEST(Tdepth_t,out_DEPTH_NB_BRANCH[context]->read(), i);
+		    }
+		  SC_START(0);
+		  
+		  LABEL("PREDICT         [%d] %d - %d (accurate : %d).",port,in_PREDICT_VAL [port]->read(),out_PREDICT_ACK [port]->read(), in_PREDICT_BTB_IS_ACCURATE [port]->read());
+		  
+		  if (in_PREDICT_VAL [port]->read() and out_PREDICT_ACK [port]->read())
+		    {
+		      LABEL("PREDICT         [%d] - Transaction accepted",port);
+		      find = true;
+		    }
+		  
+		  SC_START(1);
+		  
+		} while (not find);
+	      in_PREDICT_VAL              [port]->write(0);
+	      
+	      if (_param->_have_port_depth)
+		{
+		  TEST(Tdepth_t,out_DEPTH_TAIL     [context]->read(), 0);
+		  TEST(Tdepth_t,out_DEPTH_NB_BRANCH[context]->read(), i+1);
+		}
+	    }
+	}
+	
+	LABEL("DECOD - hit ifetch");
+	
+	{
+	  uint32_t port = rand() % _param->_nb_inst_decod;
+	  
+	  for (uint32_t i=0; i<_param->_size_queue[context]; i++)
+	    {
+	      
+	      bool find = false;
+	      do
+		{
+		  in_DECOD_VAL                  [port]->write((rand()%100)<percent_transaction_decod);
+		  in_DECOD_CONTEXT_ID           [port]->write(context);
+		  in_DECOD_BTB_ADDRESS_SRC      [port]->write(0xdeadbeef+i);
+		  in_DECOD_BTB_ADDRESS_DEST     [port]->write(0x21071981+i);
+		  in_DECOD_BTB_CONDITION        [port]->write(BRANCH_CONDITION_FLAG_SET);
+		  in_DECOD_BTB_LAST_TAKE        [port]->write(1);
+		  in_DECOD_RAS_ADDRESS          [port]->write(0xdeaddead+i);
+		  in_DECOD_RAS_INDEX            [port]->write((0x12345678+i)%_param->_size_ras_index[context]);
+		  in_DECOD_MISS_PREDICTION      [port]->write(false);
+		  in_DECOD_UPDATE_PREDICTION_ID [port]->write(i);
+		  
+		  if (_param->_have_port_depth)
+		    {
+		      TEST(Tdepth_t,out_DEPTH_TAIL     [context]->read(), 0);
+		      TEST(Tdepth_t,out_DEPTH_NB_BRANCH[context]->read(), _param->_size_queue[context]);
+		    }
+		  
+		  SC_START(0);
+		  
+		  LABEL("DECOD           [%d] %d - %d.",port,in_DECOD_VAL [port]->read(),out_DECOD_ACK [port]->read());
+		  
+		  if (in_DECOD_VAL [port]->read() and out_DECOD_ACK [port]->read())
+		    {
+		      LABEL("DECOD           [%d] - Transaction accepted",port);
+		      find = true;
+		    }
+		  
+		  SC_START(1);
+		  
+		} while (not find);
+	      in_DECOD_VAL              [port]->write(0);
+	      
+	      if (_param->_have_port_depth)
+		{
+		  TEST(Tdepth_t,out_DEPTH_TAIL     [context]->read(), 0);
+		  TEST(Tdepth_t,out_DEPTH_NB_BRANCH[context]->read(), _param->_size_queue[context]);
+		}
+	    }
+	}
+	
+	LABEL("BRANCH_COMPLETE - hit ifetch");
+	
+	{
+	  uint32_t port = rand() % _param->_nb_inst_branch_complete;
+	  
+	  for (uint32_t i=0; i<_param->_size_queue[context]; i++)
+	    {
+	      bool find = false;
+	      do
+		{
+		  in_BRANCH_COMPLETE_VAL                  [port]->write((rand()%100)<percent_transaction_branch_complete);
+		  in_BRANCH_COMPLETE_CONTEXT_ID           [port]->write(context);
+		  in_BRANCH_COMPLETE_DEPTH                [port]->write(i);
+		  in_BRANCH_COMPLETE_ADDRESS              [port]->write(0xcacacaca+i);
+		  in_BRANCH_COMPLETE_FLAG                 [port]->write(1);
+		  
+		  if (_param->_have_port_depth)
+		    {
+		      TEST(Tdepth_t,out_DEPTH_TAIL     [context]->read(), 0);
+		      TEST(Tdepth_t,out_DEPTH_NB_BRANCH[context]->read(), _param->_size_queue[context]);
+		    }
+		  
+		  SC_START(0);
+		  
+		  LABEL("BRANCH_COMPLETE [%d] %d - %d.",port,in_BRANCH_COMPLETE_VAL [port]->read(),out_BRANCH_COMPLETE_ACK [port]->read());
+		  
+		  if (in_BRANCH_COMPLETE_VAL [port]->read() and out_BRANCH_COMPLETE_ACK [port]->read())
+		    {
+		      LABEL("BRANCH_COMPLETE [%d] - Transaction accepted",port);
+		      find = true;
+		      
+		      TEST(Tcontrol_t,out_BRANCH_COMPLETE_MISS_PREDICTION[port]->read(),0);
+		      TEST(Tcontrol_t,out_BRANCH_COMPLETE_TAKE           [port]->read(),1);
+		      TEST(Taddress_t,out_BRANCH_COMPLETE_ADDRESS_SRC    [port]->read(),0xdeadbeef+i);
+		      TEST(Taddress_t,out_BRANCH_COMPLETE_ADDRESS_DEST   [port]->read(),0x21071981+i);
+		    }
+		  
+		  SC_START(1);
+
+		} while (not find);
+	      in_BRANCH_COMPLETE_VAL              [port]->write(0);
+	      
+	      if (_param->_have_port_depth)
+		{
+		  TEST(Tdepth_t,out_DEPTH_TAIL     [context]->read(), 0);
+		  TEST(Tdepth_t,out_DEPTH_NB_BRANCH[context]->read(), _param->_size_queue[context]);
+		}
+	    }
+	}
+	
+	LABEL("UPDATE - hit ifetch");
+	
+	{
+	  uint32_t port = 0; //rand() % _param->_nb_inst_update;
+	  
+	  for (uint32_t i=0; i<_param->_size_queue[context]; i++)
+	    {
+	      bool find = false;
+	      do
+		{
+		  in_UPDATE_ACK [port]->write((rand()%100)<percent_transaction_update);
+		  
+		  SC_START(0);
+		  
+		  if (out_UPDATE_VAL [port]->read() and in_UPDATE_ACK [port]->read())
+		    {
+		      LABEL("UPDATE [%d] - Transaction accepted",port);
+		      
+		      find = true;
+		      
+		      TEST(Tcontext_t         ,out_UPDATE_CONTEXT_ID            [port]->read(), context);
+		      TEST(Tcontrol_t         ,out_UPDATE_MISS_PREDICTION       [port]->read(), 0);
+		      TEST(Tcontrol_t         ,out_UPDATE_DIRECTION_GOOD        [port]->read(), 1);
+		      TEST(Tcontrol_t         ,out_UPDATE_BTB_VAL               [port]->read(), 1);
+		      TEST(Taddress_t         ,out_UPDATE_BTB_ADDRESS_SRC       [port]->read(), 0xdeadbeef+i);
+		      TEST(Taddress_t         ,out_UPDATE_BTB_ADDRESS_DEST      [port]->read(), 0x21071981+i);	      
+		      TEST(Tbranch_condition_t,out_UPDATE_BTB_CONDITION         [port]->read(), BRANCH_CONDITION_FLAG_SET);
+		      TEST(Tcontrol_t         ,out_UPDATE_DIR_VAL               [port]->read(), 1);
+		      if (_param->_have_port_history)
+			TEST(Thistory_t         ,out_UPDATE_DIR_HISTORY           [port]->read(), i);
+		      TEST(Tcontrol_t         ,out_UPDATE_RAS_VAL               [port]->read(), 0);
+		      TEST(Taddress_t         ,out_UPDATE_RAS_ADDRESS           [port]->read(), 0xdeaddead+i);
+		      TEST(Tptr_t             ,out_UPDATE_RAS_INDEX             [port]->read(), (0x12345678+i)%_param->_size_ras_index[context]);
+		      TEST(Tcontrol_t         ,out_UPDATE_RAS_PREDICTION_IFETCH [port]->read(), 1);
+		    }
+		  
+		  SC_START(1);
+		  
+		} while (not find);
+	      in_UPDATE_ACK              [port]->write(0);
+	    }
+	  
+	  LABEL("Wait a moment");
+	  SC_START(2*_param->_size_queue[context]);
+  
+	  // wait the garbage collector
+	  if (_param->_have_port_depth)
+	    while ((out_DEPTH_TAIL     [context]->read() != 0) and
+		   (out_DEPTH_NB_BRANCH[context]->read() != 0))
+	      {
+		LABEL("DEPTH [%d] nb_branch : %d - tail : %d",context,out_DEPTH_NB_BRANCH[context]->read(), out_DEPTH_TAIL [context]->read());
+		SC_START(1);
+	      }
+	}
+      }
+
+      {
+	uint32_t context = rand() % _param->_nb_context;
+	
+// 	LABEL("KANE : %d",context);
+
+	LABEL("PREDICT - fill the queue");
+	
+	{
+	  uint32_t port = rand() % _param->_nb_inst_predict;
+	  
+	  for (uint32_t i=0; i<_param->_size_queue[context]; i++)
+	    {
+	      
+	      bool find = false;
+	      do
+		{
+		  in_PREDICT_VAL              [port]->write((rand()%100)<percent_transaction_predict);
+		  in_PREDICT_CONTEXT_ID       [port]->write(context);
+		  in_PREDICT_BTB_ADDRESS_SRC  [port]->write(0xdeadbeef+i);
+		  in_PREDICT_BTB_ADDRESS_DEST [port]->write(0x21071981+i);
+		  in_PREDICT_BTB_CONDITION    [port]->write(BRANCH_CONDITION_FLAG_SET);
+		  in_PREDICT_BTB_LAST_TAKE    [port]->write(1);
+		  in_PREDICT_BTB_IS_ACCURATE  [port]->write((rand()%100)<percent_transaction_predict);
+		  in_PREDICT_DIR_HISTORY      [port]->write(i);
+		  in_PREDICT_RAS_ADDRESS      [port]->write(0xdeaddead+i);
+		  in_PREDICT_RAS_INDEX        [port]->write((0x12345678+i)%_param->_size_ras_index[context]);
+		  
+		  if (_param->_have_port_depth)
+		    {
+		      TEST(Tdepth_t,out_DEPTH_TAIL     [context]->read(), 0);
+		      TEST(Tdepth_t,out_DEPTH_NB_BRANCH[context]->read(), i);
+		    }
+		  SC_START(0);
+		  
+		  LABEL("PREDICT         [%d] %d - %d (accurate : %d).",port,in_PREDICT_VAL [port]->read(),out_PREDICT_ACK [port]->read(), in_PREDICT_BTB_IS_ACCURATE [port]->read());
+		  
+		  if (in_PREDICT_VAL [port]->read() and out_PREDICT_ACK [port]->read())
+		    {
+		      LABEL("PREDICT         [%d] - Transaction accepted",port);
+		      find = true;
+		    }
+		  
+		  SC_START(1);
+		  
+		} while (not find);
+	      in_PREDICT_VAL              [port]->write(0);
+	      
+	      if (_param->_have_port_depth)
+		{
+		  TEST(Tdepth_t,out_DEPTH_TAIL     [context]->read(), 0);
+		  TEST(Tdepth_t,out_DEPTH_NB_BRANCH[context]->read(), i+1);
+		}
+	    }
+	}
+	
+	LABEL("DECOD - hit ifetch");
+	
+	{
+	  uint32_t port = rand() % _param->_nb_inst_decod;
+	  
+	  for (uint32_t i=0; i<_param->_size_queue[context]; i++)
+	    {
+	      
+	      bool find = false;
+	      do
+		{
+		  in_DECOD_VAL                  [port]->write((rand()%100)<percent_transaction_decod);
+		  in_DECOD_CONTEXT_ID           [port]->write(context);
+		  in_DECOD_BTB_ADDRESS_SRC      [port]->write(0xdeadbeef+i);
+		  in_DECOD_BTB_ADDRESS_DEST     [port]->write(0x21071981+i);
+		  in_DECOD_BTB_CONDITION        [port]->write(BRANCH_CONDITION_FLAG_SET);
+		  in_DECOD_BTB_LAST_TAKE        [port]->write(1);
+		  in_DECOD_RAS_ADDRESS          [port]->write(0xdeaddead+i);
+		  in_DECOD_RAS_INDEX            [port]->write((0x12345678+i)%_param->_size_ras_index[context]);
+		  in_DECOD_MISS_PREDICTION      [port]->write(false);
+		  in_DECOD_UPDATE_PREDICTION_ID [port]->write(i);
+		  
+		  if (_param->_have_port_depth)
+		    {
+		      TEST(Tdepth_t,out_DEPTH_TAIL     [context]->read(), 0);
+		      TEST(Tdepth_t,out_DEPTH_NB_BRANCH[context]->read(), _param->_size_queue[context]);
+		    }
+		  
+		  SC_START(0);
+		  
+		  LABEL("DECOD           [%d] %d - %d.",port,in_DECOD_VAL [port]->read(),out_DECOD_ACK [port]->read());
+		  
+		  if (in_DECOD_VAL [port]->read() and out_DECOD_ACK [port]->read())
+		    {
+		      LABEL("DECOD           [%d] - Transaction accepted",port);
+		      find = true;
+		    }
+		  
+		  SC_START(1);
+		  
+		} while (not find);
+	      in_DECOD_VAL              [port]->write(0);
+	      
+	      if (_param->_have_port_depth)
+		{
+		  TEST(Tdepth_t,out_DEPTH_TAIL     [context]->read(), 0);
+		  TEST(Tdepth_t,out_DEPTH_NB_BRANCH[context]->read(), _param->_size_queue[context]);
+		}
+	    }
+	}
+	
+	LABEL("BRANCH_COMPLETE - hit ifetch");
+	
+	{
+	  uint32_t port = rand() % _param->_nb_inst_branch_complete;
+	  
+	    {
+	      uint32_t i=0;
+	      bool find = false;
+	      do
+		{
+		  in_BRANCH_COMPLETE_VAL                  [port]->write((rand()%100)<percent_transaction_branch_complete);
+		  in_BRANCH_COMPLETE_CONTEXT_ID           [port]->write(context);
+		  in_BRANCH_COMPLETE_DEPTH                [port]->write(i);
+		  in_BRANCH_COMPLETE_ADDRESS              [port]->write(0xcacacaca+i);
+		  in_BRANCH_COMPLETE_FLAG                 [port]->write(0);
+		  
+		  if (_param->_have_port_depth)
+		    {
+		      TEST(Tdepth_t,out_DEPTH_TAIL     [context]->read(), 0);
+		      TEST(Tdepth_t,out_DEPTH_NB_BRANCH[context]->read(), _param->_size_queue[context]);
+		    }
+		  
+		  SC_START(0);
+		  
+		  LABEL("BRANCH_COMPLETE [%d] %d - %d.",port,in_BRANCH_COMPLETE_VAL [port]->read(),out_BRANCH_COMPLETE_ACK [port]->read());
+		  
+		  if (in_BRANCH_COMPLETE_VAL [port]->read() and out_BRANCH_COMPLETE_ACK [port]->read())
+		    {
+		      LABEL("BRANCH_COMPLETE [%d] - Transaction accepted",port);
+		      find = true;
+		      
+		      TEST(Tcontrol_t,out_BRANCH_COMPLETE_MISS_PREDICTION[port]->read(),1);
+		      TEST(Tcontrol_t,out_BRANCH_COMPLETE_TAKE           [port]->read(),0);
+		      TEST(Taddress_t,out_BRANCH_COMPLETE_ADDRESS_SRC    [port]->read(),0xdeadbeef+i);
+		      TEST(Taddress_t,out_BRANCH_COMPLETE_ADDRESS_DEST   [port]->read(),0x21071981+i);
+		    }
+		  
+		  SC_START(1);
+
+		} while (not find);
+	      in_BRANCH_COMPLETE_VAL              [port]->write(0);
+	    }
+	}
+	
+	LABEL("UPDATE - miss ifetch");
+	
+	{
+	  uint32_t port = 0; //rand() % _param->_nb_inst_update;
+	  
+// 	  for (uint32_t i=0; i<_param->_size_queue[context]; i++)
+	    {
+	      uint32_t i=0;
+
+	      bool find = false;
+	      do
+		{
+		  in_UPDATE_ACK [port]->write((rand()%100)<percent_transaction_update);
+		  
+		  SC_START(0);
+		  
+		  if (out_UPDATE_VAL [port]->read() and in_UPDATE_ACK [port]->read())
+		    {
+		      LABEL("UPDATE [%d] - Transaction accepted",port);
+		      
+		      find = true;
+		      
+		      TEST(Tcontext_t         ,out_UPDATE_CONTEXT_ID            [port]->read(), context);
+		      TEST(Tcontrol_t         ,out_UPDATE_MISS_PREDICTION       [port]->read(), 1);
+		      TEST(Tcontrol_t         ,out_UPDATE_DIRECTION_GOOD        [port]->read(), 0);
+		      TEST(Tcontrol_t         ,out_UPDATE_BTB_VAL               [port]->read(), 1);
+		      TEST(Taddress_t         ,out_UPDATE_BTB_ADDRESS_SRC       [port]->read(), 0xdeadbeef+i);
+		      TEST(Taddress_t         ,out_UPDATE_BTB_ADDRESS_DEST      [port]->read(), 0x21071981+i);	      
+		      TEST(Tbranch_condition_t,out_UPDATE_BTB_CONDITION         [port]->read(), BRANCH_CONDITION_FLAG_SET);
+		      TEST(Tcontrol_t         ,out_UPDATE_DIR_VAL               [port]->read(), 1);
+		      if (_param->_have_port_history)
+			TEST(Thistory_t         ,out_UPDATE_DIR_HISTORY           [port]->read(), i);
+		      TEST(Tcontrol_t         ,out_UPDATE_RAS_VAL               [port]->read(), 0);
+		      TEST(Taddress_t         ,out_UPDATE_RAS_ADDRESS           [port]->read(), 0xdeaddead+i);
+		      TEST(Tptr_t             ,out_UPDATE_RAS_INDEX             [port]->read(), (0x12345678+i)%_param->_size_ras_index[context]);
+		      TEST(Tcontrol_t         ,out_UPDATE_RAS_PREDICTION_IFETCH [port]->read(), 1);
+		    }
+		  
+		  SC_START(1);
+		  
+		} while (not find);
+	      in_UPDATE_ACK              [port]->write(0);
+	    }
+	    
+	    LABEL("Wait a moment");
+	    SC_START(_param->_size_queue[context]);
+	    
+	    // wait the garbage collector
+	    if (_param->_have_port_depth)
+	      while ((out_DEPTH_TAIL     [context]->read() != 0) and
+		     (out_DEPTH_NB_BRANCH[context]->read() != 0))
+		{
+		  LABEL("DEPTH [%d] nb_branch : %d - tail : %d",context,out_DEPTH_NB_BRANCH[context]->read(), out_DEPTH_TAIL [context]->read());
+		  SC_START(1);
+		}
+	}
+      }
+
+      LABEL ("Yo1");
       SC_START(1);
+      LABEL ("Yo2");
+
     }
 
@@ -119,4 +646,66 @@
   delete in_CLOCK;
   delete in_NRESET;
+
+  // ~~~~~[ Interface : "predict" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+  delete []  in_PREDICT_VAL                 ;
+  delete [] out_PREDICT_ACK                 ;
+  delete []  in_PREDICT_CONTEXT_ID          ;
+  delete []  in_PREDICT_BTB_ADDRESS_SRC     ;
+  delete []  in_PREDICT_BTB_ADDRESS_DEST    ;
+  delete []  in_PREDICT_BTB_CONDITION       ;
+  delete []  in_PREDICT_BTB_LAST_TAKE       ;
+  delete []  in_PREDICT_BTB_IS_ACCURATE     ;
+  delete []  in_PREDICT_DIR_HISTORY         ;
+  delete []  in_PREDICT_RAS_ADDRESS         ;
+  delete []  in_PREDICT_RAS_INDEX           ;
+//delete [] out_PREDICT_UPDATE_PREDICTION_ID;
+  
+  // ~~~~~[ Interface : "decod" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+  delete []  in_DECOD_VAL                   ;
+  delete [] out_DECOD_ACK                   ;
+  delete []  in_DECOD_CONTEXT_ID            ;
+  delete []  in_DECOD_BTB_ADDRESS_SRC       ;
+  delete []  in_DECOD_BTB_ADDRESS_DEST      ;
+  delete []  in_DECOD_BTB_CONDITION         ;
+  delete []  in_DECOD_BTB_LAST_TAKE         ;
+  delete []  in_DECOD_RAS_ADDRESS           ;
+  delete []  in_DECOD_RAS_INDEX             ;
+  delete []  in_DECOD_MISS_PREDICTION       ;
+  delete []  in_DECOD_UPDATE_PREDICTION_ID  ;
+//delete [] out_DECOD_DEPTH                 ;
+  
+  // ~~~~~[ Interface : "branch_complete" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+  delete []  in_BRANCH_COMPLETE_VAL            ;
+  delete [] out_BRANCH_COMPLETE_ACK            ;
+  delete []  in_BRANCH_COMPLETE_CONTEXT_ID     ;
+  delete []  in_BRANCH_COMPLETE_DEPTH          ;
+  delete []  in_BRANCH_COMPLETE_ADDRESS        ;
+  delete []  in_BRANCH_COMPLETE_FLAG           ;
+  delete [] out_BRANCH_COMPLETE_MISS_PREDICTION;
+  delete [] out_BRANCH_COMPLETE_TAKE           ;
+  delete [] out_BRANCH_COMPLETE_ADDRESS_SRC    ;
+  delete [] out_BRANCH_COMPLETE_ADDRESS_DEST   ;
+  
+  // ~~~~~[ Interface : "update" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+  delete [] out_UPDATE_VAL                  ;
+  delete []  in_UPDATE_ACK                  ;
+  delete [] out_UPDATE_CONTEXT_ID           ;
+  delete [] out_UPDATE_MISS_PREDICTION      ;
+  delete [] out_UPDATE_DIRECTION_GOOD       ;
+  delete [] out_UPDATE_BTB_VAL              ;
+  delete [] out_UPDATE_BTB_ADDRESS_SRC      ;
+  delete [] out_UPDATE_BTB_ADDRESS_DEST     ;
+  delete [] out_UPDATE_BTB_CONDITION        ;
+  delete [] out_UPDATE_DIR_VAL              ;
+  delete [] out_UPDATE_DIR_HISTORY          ;
+  delete [] out_UPDATE_RAS_VAL              ;
+  delete [] out_UPDATE_RAS_ADDRESS          ;
+  delete [] out_UPDATE_RAS_INDEX            ;
+  delete [] out_UPDATE_RAS_PREDICTION_IFETCH;
+
+  // ~~~~~[ Interface : "depth" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+  delete [] out_DEPTH_NB_BRANCH;
+  delete [] out_DEPTH_TAIL;
+
 #endif
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/include/Parameters.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/include/Parameters.h	(revision 78)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/include/Parameters.h	(revision 81)
@@ -24,8 +24,33 @@
   {
     //-----[ fields ]------------------------------------------------------------
+  public : uint32_t   _nb_context             ;
+  public : uint32_t * _size_queue             ; // [nb_context]
+  public : uint32_t   _size_address           ;
+  public : uint32_t   _nb_inst_predict        ;
+  public : uint32_t   _nb_inst_decod          ;
+  public : uint32_t   _nb_inst_branch_complete;
+  public : uint32_t   _nb_inst_update         ;
+  public : uint32_t   _size_history           ;
+  public : uint32_t * _size_ras_index         ; // [nb_context]
 
+  public : uint32_t   _size_context_id        ;
+  public : uint32_t   _size_depth             ;
+  public : uint32_t   _max_size_ras_index     ;
+		      
+  public : bool       _have_port_context_id   ;
+  public : bool       _have_port_depth        ;
+  public : bool       _have_port_history      ;
+    
     //-----[ methods ]-----------------------------------------------------------
-  public : Parameters  ();
-//   public : Parameters  (Parameters & param) ;
+  public : Parameters  (uint32_t   nb_context             ,
+			uint32_t * size_queue             ,
+			uint32_t   size_address           ,
+			uint32_t   nb_inst_predict        ,
+			uint32_t   nb_inst_decod          ,
+			uint32_t   nb_inst_branch_complete,
+			uint32_t   nb_inst_update         ,
+			uint32_t   size_history           ,
+			uint32_t * size_ras_index         );
+//public : Parameters  (Parameters & param) ;
   public : ~Parameters () ;
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/include/Types.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/include/Types.h	(revision 78)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/include/Types.h	(revision 81)
@@ -19,4 +19,27 @@
 namespace update_prediction_table {
 
+  typedef enum
+    {
+      UPDATE_PREDICTION_STATE_EMPTY      , // Slot is empty
+      UPDATE_PREDICTION_STATE_WAIT_DECOD , // Fetch have access at the predictor
+      UPDATE_PREDICTION_STATE_WAITEND    , // Have make a prediction, wait branch_complete
+      UPDATE_PREDICTION_STATE_OK         , // branch is complete and can update predictor
+      UPDATE_PREDICTION_STATE_KO         , // have a event - must update predictor unit
+      UPDATE_PREDICTION_STATE_END          // branch is updated 
+    } state_t;
+
+  class entry_t
+  {
+  public : state_t             _state;
+  public : Tcontrol_t          _ifetch_prediction;
+  public : Tbranch_condition_t _condition;
+  public : Taddress_t          _address_src;
+  public : Taddress_t          _address_dest;
+  public : Tcontrol_t          _last_take;
+  public : Tcontrol_t          _good_take;
+  public : Thistory_t          _history;
+  public : Taddress_t          _address_ras;
+  public : Tptr_t              _index_ras;
+  };
 
 }; // end namespace update_prediction_table
@@ -25,6 +48,22 @@
 }; // end namespace multi_front_end
 }; // end namespace core
+}; // end namespace behavioural
+  
 
-}; // end namespace behavioural
+  template<> inline std::string toString<morpheo::behavioural::core::multi_front_end::front_end::prediction_unit::update_prediction_table::state_t>(const morpheo::behavioural::core::multi_front_end::front_end::prediction_unit::update_prediction_table::state_t& x)
+  {
+    switch (x)
+      {
+      case morpheo::behavioural::core::multi_front_end::front_end::prediction_unit::update_prediction_table::UPDATE_PREDICTION_STATE_EMPTY      : return "empty"     ; break;
+      case morpheo::behavioural::core::multi_front_end::front_end::prediction_unit::update_prediction_table::UPDATE_PREDICTION_STATE_WAIT_DECOD : return "wait_decod"; break;
+      case morpheo::behavioural::core::multi_front_end::front_end::prediction_unit::update_prediction_table::UPDATE_PREDICTION_STATE_WAITEND    : return "waitend"   ; break;
+      case morpheo::behavioural::core::multi_front_end::front_end::prediction_unit::update_prediction_table::UPDATE_PREDICTION_STATE_OK         : return "ok"        ; break;
+      case morpheo::behavioural::core::multi_front_end::front_end::prediction_unit::update_prediction_table::UPDATE_PREDICTION_STATE_KO         : return "ko"        ; break;
+      case morpheo::behavioural::core::multi_front_end::front_end::prediction_unit::update_prediction_table::UPDATE_PREDICTION_STATE_END        : return "end"       ; break;
+      default    : return ""      ; break;
+      }
+  };
+
+
 }; // end namespace morpheo              
 
